#!/usr/bin/perl -w
# Stat.pl Version 1.2
# for the last version and information
# visit : http://www.bursztein.net/prog/stat/index.html
# Change Log:
#
# local OU modifications:
#
# version 1.2
#       mysqld stats added
#       apache-status added
#       Linux uptime fix
#
# version 1.1
#       ping latency added
#       irc session count
#       shoutcast session count
#       BSD uptime fix
#       Load warning fix 
# 
# version 1.0
#       full rewrite, add more feature
#
# last revision dec 10 2001
# Based on original version by Jon Anhold <jon@snoopy.net>
# Modifications by Jeremy Weatherford <xidus@xidus.net>
# Fully rewrite by Elie aka "Lupin" Bursztein <elie@bursztein.net>
# Now working on linux and BSD, do more precise stats, and more stats.
# This script is design to work with mrtg. it provide a simple and
# flexible interface to gather stats. 
# for any comment, bug or add mail to : <stat.pl@bursztein.net> 
# This code is licensed under the GNU General Public License
# Tested on Linux 2.2.19 2.4.3 FreeBSD 4.3
# License text may be found at: http://www.gnu.org/copyleft/gpl.html
# Thank's to : GNusy, Flusher and Killer ;)
use strict;


#for usage juste type ./stat.pl to get help


#########################
#               CONFIGURATION   # 
#########################
#please select your unix : LINUX or BSD 
my $unix = "LINUX";


#this variable is use to multiplie the number because mrtg
#only use int, if rrd please setup to 1
my $mrtg = 100;


#mysql variables : to use with mysql admin
my $msqluser = "root";
my $msqlpass = "iuecyi";
#####################################################################
#               DONT TOUCH UNDER THIS LINE UNLESS YOU KNOW WHAT YOU DOING       #
#####################################################################


my $name;
if (!(defined($ARGV[0]))) {
        $name = "undefined";
} else {
        $name = $ARGV[0];
}
my $var = $name;
$var = $ARGV[1] if $ARGV[1];


my ($ligne, $data, $data1);


if ($name eq "load") {
        $ligne = `uptime`;
        if ( $unix eq "LINUX") {
                $ligne =~ /average:.+, ([\d.]+), ([\d.]+)/;
                $data = $1;
                $data1 = $2;
        } else {
                $ligne =~ /averages:.+, ([\d.]+), ([\d.]+)/;
                $data = $1;
                $data1 = $2;
        }
        $data *= $mrtg;
        $data1*= $mrtg;
        
} elsif ($name eq "users") {
    #number of open user session and numbers of diffrents accounts
    $ligne = `w | wc -l`;
    $ligne =~ /([\d]+)/;
    $data = $1-2;
    $ligne = `users | wc -w`;
    $ligne =~ /([\d]+)/;
    $data1 = $1;
    
} elsif ($name eq "mysql") {
        $ligne = `mysqladmin -u$msqluser -p$msqlpass status`;
        if ($var eq "query" || !defined($var)) {
                $ligne=~ /Queries per second avg: (\d.\d+)/;
                $data1 = $data = $1 * $mrtg;
        }
        if ($var eq "threads") {
                $ligne=~ /Threads: (\d+)/;
                $data1 = $data = $1 * $mrtg;
        }
        if ($var eq "slow") {
                $ligne=~ /Slow queries: (\d+)/;
                $data1 = $data = $1 * $mrtg;
        }
        if ($var eq "opens") {
                $ligne=~ /Opens: (\d+)/;
                $data1 = $data = $1 * $mrtg;
        }
} elsif ($name eq "procs") {
    $ligne = `ps auxc | wc -l`;
    $ligne =~ /(\d+)/;
    $data = $1 - 3;
    $data1 = $data;
    
} elsif ($name eq "uptime") {
        if ($unix eq "LINUX") {
                $ligne = `cat /proc/uptime`;
                $ligne =~ /(\d+).*/;
                        $data = $1;
                        $data /= 86400;
        } else {
        #here we do a tricky parsing because i didn't find a way to 
        #to get the uptime correctly under BSD so if you find a better 
        #way please let me know
        $ligne = `uptime`;
        #do we have a day of uptime
        if ($ligne =~ /day/) { 
                if ($ligne =~ /min/) {
                         $ligne =~ /up +(\d+).*(\d+) mins/;
                         $data = $1 + $2/1440;
                } elsif ( ($ligne =~ /hrs/) or ($ligne =~ /hour/) ) {
                        $ligne =~ /up +(\d+).*(\d+) h/;
                        $data = $1;
                } else {
                        #up 14 days, 21:09,  5 user
                        $ligne =~ /up +(\d+).*(\d+):(\d+),/;
                        #calculing real uptime :) day + hours/24  + mn/1440 
                        $data = $1 + $2/24 + $3/1440;
                }
          } else { 
                        if ($ligne =~ /min/) {
                        $ligne=~ /up +(\d+) min/;
                        $data = $1/1440;
                         } elsif ( ($ligne =~ /hrs/) or ($ligne =~ /hour/) ) {
                                 $ligne =~ /up +(\d+) h/;
                                 $data = $1;
                        } else {
                                $ligne=~ /up +(\d+):(\d+),/;
                                $data = $1/24 + $2/1440;
                        }
                }
        }
    $data *= $mrtg;
    $data1 = $data;
    
} elsif ($name eq "harddrive") {
    #return the total and the used
     $ligne = `df -m |grep $var`;
     $ligne =~  /^[\/0-9a-zA-Z]+ *(\d+) *(\d+)/;
     $data1 = $1;
     $data  = $2;
     
} elsif ($name eq "mem") {
        #need a fix use : free
    $ligne = `free | grep Mem`;
    $ligne =~ /^Mem: *(\d+) *(\d+)/;
    #$1 total $2 used
    $data = $1;
    $data1 = $2;
    
} elsif ($name eq "memnocache") {
    #need a fix on BSD : free isn't installed by default
    $ligne = `free | grep cache`;
    $ligne =~ /cache: *(\d+) *(\d+)/;
    #$1 used $2 free so we need to do a sum for $data1
    $data = $1;
    $data1 = $1 + $2;
    
} elsif ($name eq "swap") {
    #need a fix on BSD : free
    $ligne = `free | grep Swap`;
    $ligne =~ /Swap: *(\d+) *(\d+)/;
    #$1 total $2 used
    $data = $1;
    $data1 = $2;
  
} elsif ($name eq "apache-status") {
        if ($var eq "bytes" || !defined($var)) {
                $ligne = `/usr/bin/lynx -dump http://localhost:80/server-status?auto | grep BytesPerSec`;
                $ligne =~ /.*BytesPerSec.*: (\d+).*/;
                $data = $data1 = $1;
        } elsif ($var eq "req") {
                $ligne = `/usr/bin/lynx -dump http://localhost:80/server-status?auto | grep ReqPerSec`;
                $ligne =~ /.*ReqPerSec.*: (\d+).*/;
                 $data1 = $data = $1;
        } elsif ($var eq "servers") {
                $ligne = `/usr/bin/lynx -dump http://localhost:80/server-status?auto | grep BusyServers`;
                $ligne =~ /BusyServers.*: (\d+)/;
                $data1 = $data = $1;
        } else {
                print "error please read the help\n";
        }
} elsif ($name eq "tcpopen") {
    #giving all the tcp ESTABLISHED
    $ligne = `netstat -tn | grep ESTABLISHED | wc -l`;
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;

} elsif ($name eq "ircopen") {
        #giving the irc session (6667) ESTABLISHED
        if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:6667.*ESTABLISHED' | wc -l`;
    } else {
        $ligne = `netstat -tn|grep '.6667 .*ESTABLISHED'| wc -l`;
            }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;

} elsif ($name eq "javaopen") {
        #giving the irc session (5523) ESTABLISHED
        if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:5523.*ESTABLISHED' | wc -l`;
    } else {
          $ligne = `netstat -tn|grep '.5523 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;
    
} elsif ($name eq "ftpopen") {
        #giving the ftp session (21) ESTABLISHED
        if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:21.*ESTABLISHED' | wc -l`;
    } else {
        $ligne = `netstat -tn|grep '.21 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;


} elsif ($name eq "sshopen") {
        #giving the ssh session (22) ESTABLISHED
    if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:22.*ESTABLISHED' | wc -l`;
    } else {
                $ligne = `netstat -tn|grep '.22 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;


} elsif ($name eq "telnetopen") {
        #giving the telnet session (23) ESTABLISHED
    if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:23.*ESTABLISHED' | wc -l`;
    } else {
                $ligne = `netstat -tn|grep '.23 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;
    
} elsif ($name eq "smtpopen") {
        #giving the smtp session (25) ESTABLISHED
    if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:25.*ESTABLISHED' | wc -l`;
    } else {
                $ligne = `netstat -tn|grep '.25 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data; 


} elsif ($name eq "httpopen") {
        #giving the http session (80) ESTABLISHED
    if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:80.*ESTABLISHED' | wc -l`;
    } else {
                $ligne = `netstat -tn|grep '.80 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;   
    
} elsif ($name eq "pop3open") {
        #giving the pop3 session (110) ESTABLISHED
    if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:110.*ESTABLISHED' | wc -l`;
    } else {
                $ligne = `netstat -tn|grep '.110 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;


} elsif ($name eq "nntpopen") {
        #giving the news session (119) ESTABLISHED
    if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:119.*ESTABLISHED' | wc -l`;
    } else {
                $ligne = `netstat -tn|grep '.119 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;
    
} elsif ($name eq "netbiosopen") {
        #giving the netbios session (139) ESTABLISHED
    if ( $unix eq "LINUX") {
        $ligne = `netstat -tn | grep '.*:139.*ESTABLISHED' | wc -l`;
    } else {
                $ligne = `netstat -tn|grep '.139 .*ESTABLISHED'| wc -l`;
    }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;
    
} elsif ($name eq "imapopen") {
        #giving the imap session (143) ESTABLISHED
 	if ( $unix eq "LINUX") {
                $ligne = `netstat -tn | grep '.*:143.*ESTABLISHED' | wc -l`;
        } else {
                $ligne = `netstat -tn|grep '.143 .*ESTABLISHED'| wc -l`;
        }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;

} elsif ($name eq "shoutcastopen") {
        #giving the imap session (8000) ESTABLISHED
    if ( $unix eq "LINUX") {
                $ligne = `netstat -tn | grep '.*:8000.*ESTABLISHED' | wc -l`;
        } else {
                #$ligne = `netstat -tn|grep '.8000 .*ESTABLISHED'| wc -l`;
                ##modif pour pas prendre compte du localhost
                $ligne = `netstat -tn|grep '.8000 .*ESTABLISHED'|grep -v 127.0.0.1|wc -l`;
        }
    $ligne =~ /(\d+)/;
    $data = $1;
    $data1 = $data;    
    
} elsif ($name eq "mailq") {
    $ligne = `mailq | grep Requests`;
    #test if empty or not
    if ($ligne=~ /Requests/) {
        $ligne =~ /in (\d+)/;
        $data = $1;
        } else {
                $data = 0;
        }
    $data1 = $data; 
} elsif ($name eq "ping") {
        $ligne = `ping $var  -c 3 2> /dev/null | grep round-trip`;
        if ($ligne =~ /round-trip/) {
                #round-trip min/avg/max/mdev = 0.508/0.594/0.751
                $ligne =~ /^round-trip.+\/([\d.]+)\/([\d.]+)\//;
                $data=$1;
                $data1=$2;
        } else {
                $data=0;
                $data1=0;
        }
# not sure it is working
#} elsif ($name eq "dnsreqs") {
#    $ligne = `/usr/sbin/ndc stats`;
#    $ligne = `tail -3 /var/named/named.stats | head -1 | sed 's/  / /g' | cut -f 16 -d " "`;
#    $ligne =~ /(\d+)/;
#    $data = $1;
        
} else {
    $data = "0";
    $data1= "0";
    $name .= ":Unknown stats requested\n\n";
    $name .= "Stat.pl version 1.2\n";
        $name .= "General usage : stat.pl <stat> [name]\n";
    $name .= "Possible choice for <stat> :\n-local: load, users, procs, uptime, harddrive, mem, memnocache, swap\n";
    $name .= "-network: tcpopen, ftpopen, sshopen, telnetopen, smtpopen, httpopen, pop3open, nntpopen, netbiosopen, imapopen, ircopen, shoutcastopen, javaopen ping\n";
 $name .= "-service info : apache-status mysql\n";  
 $name .= "harddrive usage : stat.pl harddrive harddrivename (ie hda1)\n";
    $name .= "ping usage : stat.pl ping host (ie 10.0.0.1 or www.foo.bar)\n";
$name .= "apache-status usage : stat.pl apache-status <req|bytes|server> (req : request by second - bytes : kbytes by sec - server :number of apache server busy)\n";
$name .="mysql usage : stat.pl mysql <query|slow|opens|threads> (query : number of query by sec - slow : number of slow request - opens : number of open - threads : numbers of threads used by the server)\n";
    $name .= "\nNOTES :\n1) Be sure you have set the ".'$unix'."variable to the correct type. Possible choice BSD and LINUX\n";
    $name .= "2) Difference between mem and memnocache:\n\t-mem give the used mem with the cache included";
    $name .= "\n\t-memnocache give it without the cache";
    $name .= "\n3) Because MRTG use only integere we have multiplie some values and round it,in case you want to use rrd please set the ".'$mrtg'." to 1.\n";
        $name .= "\nThis prog come under GPL licence. For any comment, bug or add mail to : <stat.pl\@bursztein.net>\n";
        $name .="Coded by Elie aka \"Lupin\" Bursztein. Members of the L.S.E (epita system lab www.epita.fr/~lse)";
}
#for mrtg who need only integer
if ($mrtg != 1) {
$data = int($data);
$data1 = int($data1);
}
#answering :
print "$data\n";
print "$data1\n";
print "$name\n";
